class GuiStein; class GuiSpielfeld; class Brett;

enum GameMode { FreeMode, PlayMode, MultiMode };

class GuiStein : public QWidget
{
public:
	GuiStein(Stein*s,GuiSpielfeld*f,QWidget*p);
	~GuiStein() {}
protected:
	Stein *_s; GuiSpielfeld *_feld; Brett *_par; 
	QPoint _grabPos; int _grabButton,_dragPos;
	int _oldPos; QPoint _oldXY; QWidget *_oldPar;
	static const int _rootFlags;
protected:
	void setPos();
	void paintEvent(QPaintEvent*);
	void resizeEvent(QResizeEvent*);
	void mousePressEvent(QMouseEvent*e);
	void mouseReleaseEvent(QMouseEvent*e);
	void mouseMoveEvent(QMouseEvent*e);
public:
	void doCursor(int state);
	void stornoMove();
};

class Brett : public QWidget
{
public:
	Brett(GuiSpielfeld*p);
	~Brett() {}
protected:
	GuiSpielfeld *_gsf; 
	QSize _defSize;
public: 
	int _uw,_uh; QPoint _offs;
	QRect _feldRect,_depotRect; 
	QPointArray _qpa; QRegion _qrg; 
	QPixmap _qpm; QPixmap _qsf;
	int _shadowPos;
protected:
	void paintEvent(QPaintEvent*e);
	void resizeEvent(QResizeEvent*);
	void paintFeld(QPainter &p);
	void paintShadow(QPainter &p);
	QSize sizeHint() const { return _defSize; } 
public:
	void setPos(int ind);
	void changeUnitSize(int uw,int uh);
	int getPosForPoint(const QPoint &p);
	void moveOver(int pos);
};
class GuiSpielfeld : public QMainWindow, private Spielfeld
{
	Q_OBJECT
public:
	GuiSpielfeld(QWidget*p=NULL,const char*n=NULL);
	~GuiSpielfeld();
protected:
	GuiStein *_guicoll[27];
	Brett *_brt; char _seldigs[3];
	GameMode _mode; 
	QPopupMenu *_modeMenu;
	int _freeModeID,_playModeID,_multiModeID;
public:
	PixmapColl _pixcoll; QColor _bgcol;
	GuiStein *_grabWin; 
protected:
	void keyPressEvent(QKeyEvent*e);
	void keyReleaseEvent(QKeyEvent*e);
public:
	GuiStein* at(int p);
	Stein* coll(int ind) { return _coll[ind]; }
	GuiStein* guicoll(int ind) { return _guicoll[ind]; }
	Brett* getBrett() { return _brt; }
	void selNextStein();
	void setSel(int i);
	void setSelChar(char ch);
	void placeSelTo(char ch); 
	int sel() const { return Spielfeld::sel(); }
	void setPos(int ind) { _brt->setPos(ind); }
	bool placeStein(int pos,Stein*s);
	bool removeStein(Stein*s);
	bool place(int p,Stein*s);
	bool remove(int p);
	bool remove(Stein*s);
	void updateScore();
	void updateModeMenu();
	GameMode getMode() { return _mode; }
public slots:
	void newGame(); 
	void stornoMove();
	void submitStein();
	void nextStein();
	void setFreeMode();
	void setPlayMode();
	void setMultiMode();
	void resetDepot();

};
