/*                 Das Spielfeld:
              .                            .                             
                   .                           .                         
              .        10                  .       K                     
                     /    \                      /   \                   
                  06    |   15                 G   |   P                 
                /    \    /    \             /   \   /   \               
             02    |   11    |   20        C   |   L   |   U             
                \    /    \    /             \   /   \   /               
              |   07    |   16    |        |   H   |   Q   |             
                /    \    /    \             /   \   /   \               
             03    |   12    |   21        D   |   M   |   V             
                \    /    \    /             \   /   \   /               
              |   08    |   17    |        |   I   |   R   |             
                /    \    /    \             /   \   /   \               
             04    |   13    |   22        E   |   N   |   W             
                \    /    \    /             \   /   \   /               
                  09    |   18                 J   |   S                 
                     \    /                      \   /                   
                       14         .                O       .             
                             .                         .                 
                                  .                        .             
*/

class Stein; class Spielfeld;

inline int pos2x(int i) { return i/5; }
inline int pos2y(int i) { return (i%5)*2+i/5-2; }
void pos2xy(int *x,int *y,int p);
void depot2xy(int *x,int *y,int ind);
inline char pos2char(int pos) { return pos+'A'; }
inline int char2pos(char ch) { return toupper(ch)-'A'; }

int row2val(int i,int j);
int val2dir(int v);
int str2ind(const char *str);
void ind2str(char *str,int ind);

bool isvalid(int pos);
inline int max(int x,int y) { return (x>y) ? x : y; }
extern int hexagon[14];

class Stein
{
public:
	Stein(int ind);
	~Stein() {}
protected: 
	const int _ind; int _d[3]; 
	int _pos; 
public:
	int value(int dir) const { return _d[dir]; }
	int index() const { return _ind; }

	int pos() const { return _pos; }
	void place(int p) { _pos=p; }
	void remove() { _pos=-1; }
};

class Spielfeld
{
public:
	Spielfeld();
	~Spielfeld();
protected:
	Stein *_feld[27]; // Spielfeld
	Stein *_coll[27]; // Steinesammlung
	int _sel;
public:
	void setSel(int i) { if (i>=0 && i<27) _sel=i; else _sel=-1; }
	int sel() const { return _sel; }
	int count() const;
	Stein* at(int p) const { return _feld[p]; }
	Stein* get(int i) const { return _coll[i]; }
	bool place(int p,Stein *s);
	bool remove(int p);
	bool remove(Stein *s);
	void textdraw() const;
private:
	int rowsum(int p,int delta,int len) const;
public:
	void reset();
};

